"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
exports.__esModule = true;
exports.JsonLang = void 0;
var core_1 = require("../core");
var rule_1 = require("../rule");
var JsonLang = /** @class */ (function (_super) {
    __extends(JsonLang, _super);
    function JsonLang() {
        var _this = _super.call(this) || this;
        _this.registerBuiltinRules = function () {
            var mathRules = _this.mathRules.getRules();
            var logicalRules = _this.logicalRules.getRules();
            var objectRules = _this.objectRules.getRules();
            var arrayRules = _this.arrayRules.getRules();
            _this.registerMany(new Map(__spreadArray(__spreadArray(__spreadArray(__spreadArray([], __read(mathRules), false), __read(logicalRules), false), __read(objectRules), false), __read(arrayRules), false)));
        };
        _this.mathRules = new rule_1.MathRules();
        _this.logicalRules = new rule_1.LogicalRules();
        _this.objectRules = new rule_1.ObjectRules();
        _this.arrayRules = new rule_1.ArrayRules();
        _this.registerBuiltinRules();
        return _this;
    }
    return JsonLang;
}(core_1.RuleCore));
exports.JsonLang = JsonLang;
//# sourceMappingURL=app.js.map